#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './sq_thumbnailcachemaster.ui'
**
** Created: Mon Sep 15 11:04:02 2008
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "sq_thumbnailcachemaster.h"

#include <qvariant.h>
#include <qapplication.h>
#include <kdirsize.h>
#include <kio/global.h>
#include <kio/job.h>
#include <kpushbutton.h>
#include <qlabel.h>
#include <qframe.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include "kpushbutton.h"
#include "sq_viewcache.h"
#include "sq_pixmapcache.h"
#include "sq_dirthumbs.h"
#include "sq_iconloader.h"
#include "./sq_thumbnailcachemaster.ui.h"

/*
 *  Constructs a SQ_ThumbnailCacheMaster as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
SQ_ThumbnailCacheMaster::SQ_ThumbnailCacheMaster( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "SQ_ThumbnailCacheMaster" );
    setSizeGripEnabled( TRUE );
    SQ_ThumbnailCacheMasterLayout = new QGridLayout( this, 1, 1, 11, 6, "SQ_ThumbnailCacheMasterLayout"); 

    pushCache = new KPushButton( this, "pushCache" );
    pushCache->setAutoDefault( FALSE );

    SQ_ThumbnailCacheMasterLayout->addWidget( pushCache, 0, 0 );

    textThumbSize = new QLabel( this, "textThumbSize" );
    textThumbSize->setFrameShape( QLabel::StyledPanel );
    textThumbSize->setMargin( 1 );
    textThumbSize->setAlignment( int( QLabel::AlignCenter ) );

    SQ_ThumbnailCacheMasterLayout->addWidget( textThumbSize, 0, 1 );

    pushClearCache = new KPushButton( this, "pushClearCache" );
    pushClearCache->setAutoDefault( FALSE );

    SQ_ThumbnailCacheMasterLayout->addWidget( pushClearCache, 1, 0 );

    pushShowCache = new KPushButton( this, "pushShowCache" );
    pushShowCache->setAutoDefault( FALSE );

    SQ_ThumbnailCacheMasterLayout->addWidget( pushShowCache, 3, 0 );

    pushClearCacheMemory = new KPushButton( this, "pushClearCacheMemory" );
    pushClearCacheMemory->setAutoDefault( FALSE );

    SQ_ThumbnailCacheMasterLayout->addWidget( pushClearCacheMemory, 4, 0 );

    textCacheMemSize = new QLabel( this, "textCacheMemSize" );
    textCacheMemSize->setFrameShape( QLabel::StyledPanel );
    textCacheMemSize->setMargin( 1 );
    textCacheMemSize->setAlignment( int( QLabel::AlignCenter ) );

    SQ_ThumbnailCacheMasterLayout->addWidget( textCacheMemSize, 2, 1 );

    pushSyncCache = new KPushButton( this, "pushSyncCache" );
    pushSyncCache->setAutoDefault( FALSE );

    SQ_ThumbnailCacheMasterLayout->addWidget( pushSyncCache, 5, 0 );

    pushCacheMemory = new KPushButton( this, "pushCacheMemory" );
    pushCacheMemory->setAutoDefault( FALSE );

    SQ_ThumbnailCacheMasterLayout->addWidget( pushCacheMemory, 2, 0 );

    line1 = new QFrame( this, "line1" );
    line1->setFrameShape( QFrame::HLine );
    line1->setFrameShadow( QFrame::Sunken );
    line1->setFrameShape( QFrame::HLine );

    SQ_ThumbnailCacheMasterLayout->addMultiCellWidget( line1, 6, 6, 0, 1 );

    layout1 = new QHBoxLayout( 0, 0, 6, "layout1"); 
    spacer1 = new QSpacerItem( 195, 21, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout1->addItem( spacer1 );

    pushClose = new QPushButton( this, "pushClose" );
    layout1->addWidget( pushClose );

    SQ_ThumbnailCacheMasterLayout->addMultiCellLayout( layout1, 7, 7, 0, 1 );
    languageChange();
    resize( QSize(331, 244).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( pushSyncCache, SIGNAL( clicked() ), this, SLOT( slotSyncCache() ) );
    connect( pushShowCache, SIGNAL( clicked() ), this, SLOT( slotShowDiskCache() ) );
    connect( pushClearCacheMemory, SIGNAL( clicked() ), this, SLOT( slotClearMemoryCache() ) );
    connect( pushClearCache, SIGNAL( clicked() ), this, SLOT( slotClearCache() ) );
    connect( pushCacheMemory, SIGNAL( clicked() ), this, SLOT( slotCalcCacheMemory() ) );
    connect( pushCache, SIGNAL( clicked() ), this, SLOT( slotCalcCache() ) );
    connect( pushClose, SIGNAL( clicked() ), this, SLOT( reject() ) );

    // tab order
    setTabOrder( pushCache, pushClearCache );
    setTabOrder( pushClearCache, pushCacheMemory );
    setTabOrder( pushCacheMemory, pushShowCache );
    setTabOrder( pushShowCache, pushClearCacheMemory );
    setTabOrder( pushClearCacheMemory, pushSyncCache );
    setTabOrder( pushSyncCache, pushClose );
    init();
}

/*
 *  Destroys the object and frees any allocated resources
 */
SQ_ThumbnailCacheMaster::~SQ_ThumbnailCacheMaster()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void SQ_ThumbnailCacheMaster::languageChange()
{
    setCaption( tr2i18n( "Thumbnail cache" ) );
    pushCache->setText( tr2i18n( "Calculate cache size on disk" ) );
    textThumbSize->setText( QString::null );
    pushClearCache->setText( tr2i18n( "Clear cache on disk" ) );
    pushShowCache->setText( tr2i18n( "View memory cache" ) );
    pushClearCacheMemory->setText( tr2i18n( "Clear cache in memory" ) );
    textCacheMemSize->setText( QString::null );
    pushSyncCache->setText( tr2i18n( "Sync cache to disk" ) );
    pushCacheMemory->setText( tr2i18n( "Calculate cache size in memory" ) );
    pushClose->setText( tr2i18n( "Close" ) );
}

#include "sq_thumbnailcachemaster.moc"
